/// api_version=2
var script = registerScript({
    name: "PointerESP",
    version: "1.X",
    authors: ["AquaVit"]
});

var EntityPlayer = Java.type('net.minecraft.entity.player.EntityPlayer')
var EntityMob = Java.type('net.minecraft.entity.monster.EntityMob')
var EntityAnimal = Java.type('net.minecraft.entity.passive.EntityAnimal')
var EntitySquid = Java.type('net.minecraft.entity.passive.EntitySquid')
var EntitySlime = Java.type('net.minecraft.entity.monster.EntitySlime')
var GlStateManager = Java.type("net.minecraft.client.renderer.GlStateManager")
var ScaledResolution = Java.type("net.minecraft.client.gui.ScaledResolution")
var GL11 = Java.type("org.lwjgl.opengl.GL11")
var MathHelper = Java.type("net.minecraft.util.MathHelper")
var Color = Java.type('java.awt.Color')

Math.toRadians = function (degrees) {
    return degrees * Math.PI / 180;
};

function glColor(shit) {
    var alpha = (shit >> 24 & 0xFF) / 255;
    var red = (shit >> 16 & 0xFF) / 255;
    var green = (shit >> 8 & 0xFF) / 255;
    var blue = (shit & 0xFF) / 255;
    GlStateManager.color(red, green, blue, alpha);
}

function enableGL2D() {
    GL11.glDisable(2929);
    GL11.glEnable(3042);
    GL11.glDisable(3553);
    GL11.glBlendFunc(770, 771);
    GL11.glDepthMask(true);
    GL11.glEnable(2848);
    GL11.glHint(3154, 4354);
    GL11.glHint(3155, 4354);
}

function disableGL2D() {
    GL11.glEnable(3553);
    GL11.glDisable(3042);
    GL11.glEnable(2929);
    GL11.glDisable(2848);
    GL11.glHint(3154, 4352);
    GL11.glHint(3155, 4352);
}

function drawESPCircle(cx, cy, r, n, color) {
    GL11.glPushMatrix();
    cx *= 2.0;
    cy *= 2.0;
    var b = 6.2831852 / n;
    var p = Math.cos(b);
    var s = Math.sin(b);
    var x = r *= 2.0;
    var y = 0.0;
    enableGL2D();
    GL11.glScalef(0.5, 0.5, 0.5);
    GlStateManager.color(0,0,0);
    GlStateManager.resetColor();
    glColor(color);
    GL11.glBegin(2);
    var ii = 0;
    while (ii < n) {
        GL11.glVertex2f(x + cx, y + cy);
        var t = x;
        x = p * x - s * y;
        y = s * t + p * y;
        ii++;
    }
    GL11.glEnd();
    GL11.glScalef(2.0, 2.0, 2.0);
    disableGL2D();
    GlStateManager.color(1, 1, 1, 1);
    GL11.glPopMatrix();
}

script.registerModule({
    name: "PointerESP",
    description: ":/",
    category: "Render",
    tag: ">3",
    settings: {
		mode: Setting.list({
            name: "Mode",
            values: ["Solid", "Line"],
            default: "Line"
        }),
        player: Setting.boolean({
            name: "Players",
            default: true
        }),
		mob: Setting.boolean({
            name: "Mobs",
            default: false
        }),
		invis: Setting.boolean({
            name: "Invisibles",
            default: false
        }),
		animals: Setting.boolean({
            name: "Animals",
            default: false
        }),
        r: Setting.integer({
            name: "Red",
            default: 5,
            min: 0,
            max: 255
        }),
		g: Setting.integer({
            name: "Green",
            default: 5,
            min: 0,
            max: 255
        }),
		b: Setting.integer({
            name: "Blue",
            default: 5,
            min: 0,
            max: 255
        }),
		al: Setting.integer({
            name: "Alpha",
            default: 5,
            min: 0,
            max: 255
        })
    }
}, function (module) {
    module.on("render2D", function (event) {
		var a = new ScaledResolution(mc);
		GlStateManager.pushMatrix();
		var size = 50;
        var xOffset = a.getScaledWidth() / 2 - 24.5;
        var yOffset = a.getScaledHeight() / 2 - 25.2;
        var playerOffsetX = mc.thePlayer.posX;
        var playerOffSetZ = mc.thePlayer.posZ;
        for (var i in mc.theWorld.loadedEntityList){
			var entity = mc.theWorld.loadedEntityList[i]
			if (module.settings.mob.get() && (entity instanceof EntityMob || entity instanceof EntitySlime) && (module.settings.invis.get() || !entity.isInvisible())){
				var loaddist = 0.2;
                var pTicks = mc.timer.renderPartialTicks;
                var pos1 = (((entity.posX + (entity.posX - entity.lastTickPosX) * pTicks) - playerOffsetX) * loaddist);
                var pos2 = (((entity.posZ + (entity.posZ - entity.lastTickPosZ) * pTicks) - playerOffSetZ) * loaddist);
				var cos = Math.cos(mc.thePlayer.rotationYaw * (Math.PI * 2 / 360));
                var sin = Math.sin(mc.thePlayer.rotationYaw * (Math.PI * 2 / 360));
                var rotY = -(pos2 * cos - pos1 * sin);
                var rotX = -(pos1 * cos + pos2 * sin);
                var var7 = 0 - rotX;
                var var9 = 0 - rotY;
				if (MathHelper.sqrt_double(var7 * var7 + var9 * var9) < size / 2 - 4) {
                    var angle = (Math.atan2(rotY - 0, rotX - 0) * 180 / Math.PI);
                    var x = ((size / 2) * Math.cos(Math.toRadians(angle))) + xOffset + size / 2;
                    var y = ((size / 2) * Math.sin(Math.toRadians(angle))) + yOffset + size / 2;
                    GlStateManager.pushMatrix();
                    GlStateManager.translate(x, y, 0);
                    GlStateManager.rotate(angle, 0, 0, 1);
                    GlStateManager.scale(1.5, 1.0, 1.0);
					if (module.settings.mode.get() == "Solid"){
					    drawESPCircle(0, 0, 2.2, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
                        drawESPCircle(0, 0, 1.5, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
                        drawESPCircle(0, 0, 1.0, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
                        drawESPCircle(0, 0, 0.5, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
					} else {
						drawESPCircle(0, 0, 2.2, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
					}
                    GlStateManager.popMatrix();
                }
			}
			
			if (module.settings.animals.get() && (entity instanceof EntityAnimal || entity instanceof EntitySquid) && (module.settings.invis.get() || !entity.isInvisible())){
				var loaddist = 0.2;
                var pTicks = mc.timer.renderPartialTicks;
                var pos1 = (((entity.posX + (entity.posX - entity.lastTickPosX) * pTicks) - playerOffsetX) * loaddist);
                var pos2 = (((entity.posZ + (entity.posZ - entity.lastTickPosZ) * pTicks) - playerOffSetZ) * loaddist);
				var cos = Math.cos(mc.thePlayer.rotationYaw * (Math.PI * 2 / 360));
                var sin = Math.sin(mc.thePlayer.rotationYaw * (Math.PI * 2 / 360));
                var rotY = -(pos2 * cos - pos1 * sin);
                var rotX = -(pos1 * cos + pos2 * sin);
                var var7 = 0 - rotX;
                var var9 = 0 - rotY;
				if (MathHelper.sqrt_double(var7 * var7 + var9 * var9) < size / 2 - 4) {
                    var angle = (Math.atan2(rotY - 0, rotX - 0) * 180 / Math.PI);
                    var x = ((size / 2) * Math.cos(Math.toRadians(angle))) + xOffset + size / 2;
                    var y = ((size / 2) * Math.sin(Math.toRadians(angle))) + yOffset + size / 2;
                    GlStateManager.pushMatrix();
                    GlStateManager.translate(x, y, 0);
                    GlStateManager.rotate(angle, 0, 0, 1);
                    GlStateManager.scale(1.5, 1.0, 1.0);
					if (module.settings.mode.get() == "Solid"){
					    drawESPCircle(0, 0, 2.2, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
                        drawESPCircle(0, 0, 1.5, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
                        drawESPCircle(0, 0, 1.0, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
                        drawESPCircle(0, 0, 0.5, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
					} else {
						drawESPCircle(0, 0, 2.2, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
					}
                    GlStateManager.popMatrix();
                }
			}
			
			if (module.settings.player.get() && (entity instanceof EntityPlayer && entity != mc.thePlayer) && (module.settings.invis.get() || !entity.isInvisible())){
				var loaddist = 0.2;
                var pTicks = mc.timer.renderPartialTicks;
                var pos1 = (((entity.posX + (entity.posX - entity.lastTickPosX) * pTicks) - playerOffsetX) * loaddist);
                var pos2 = (((entity.posZ + (entity.posZ - entity.lastTickPosZ) * pTicks) - playerOffSetZ) * loaddist);
				var cos = Math.cos(mc.thePlayer.rotationYaw * (Math.PI * 2 / 360));
                var sin = Math.sin(mc.thePlayer.rotationYaw * (Math.PI * 2 / 360));
                var rotY = -(pos2 * cos - pos1 * sin);
                var rotX = -(pos1 * cos + pos2 * sin);
                var var7 = 0 - rotX;
                var var9 = 0 - rotY;
				if (MathHelper.sqrt_double(var7 * var7 + var9 * var9) < size / 2 - 4) {
                    var angle = (Math.atan2(rotY - 0, rotX - 0) * 180 / Math.PI);
                    var x = ((size / 2) * Math.cos(Math.toRadians(angle))) + xOffset + size / 2;
                    var y = ((size / 2) * Math.sin(Math.toRadians(angle))) + yOffset + size / 2;
                    GlStateManager.pushMatrix();
                    GlStateManager.translate(x, y, 0);
                    GlStateManager.rotate(angle, 0, 0, 1);
                    GlStateManager.scale(1.5, 1.0, 1.0);
                    if (module.settings.mode.get() == "Solid"){
					    drawESPCircle(0, 0, 2.2, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
                        drawESPCircle(0, 0, 1.5, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
                        drawESPCircle(0, 0, 1.0, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
                        drawESPCircle(0, 0, 0.5, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
					} else {
						drawESPCircle(0, 0, 2.2, 3, new Color(module.settings.r.get(),module.settings.g.get(),module.settings.b.get(),module.settings.al.get()).getRGB());
					}                    
					GlStateManager.popMatrix();
                }
			}
		}
		GlStateManager.popMatrix();
    });
});